package com.gxwebsoft.shop.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gxwebsoft.common.core.utils.JSONUtil;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.entity.*;
import com.gxwebsoft.shop.service.GoodsService;
import com.gxwebsoft.shop.param.GoodsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.GoodsSkuService;
import com.gxwebsoft.shop.service.GoodsSpecService;
import com.gxwebsoft.shop.service.MerchantService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 商品记录表控制器
 *
 * @author 科技小王子
 * @since 2024-07-25 19:22:01
 */
@Api(tags = "商品记录表管理")
@RestController
@RequestMapping("/api/shop/goods")
public class GoodsController extends BaseController {
  @Resource
  private GoodsService goodsService;
  @Resource
  private GoodsSpecService goodsSpecService;
  @Resource
  private GoodsSkuService goodsSkuService;
  @Resource
  private MerchantService merchantService;

    @ApiOperation("分页查询商品记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Goods>> page(GoodsParam param) {
      final User loginUser = getLoginUser();
      param.setLoginUser(loginUser);
      return success(goodsService.pageRel(param));
    }

    @ApiOperation("查询全部商品记录表")
    @GetMapping()
    public ApiResult<List<Goods>> list(GoodsParam param) {
        // 使用关联查询
        return success(goodsService.listRel(param));
    }

    @ApiOperation("根据id查询商品记录表")
    @GetMapping("/{id}")
    public ApiResult<Goods> get(@PathVariable("id") Integer id) {
        // 使用关联查询
      final Goods goods = goodsService.getByIdRel(id);

      // 提取specValue
      final GoodsSpec spec = goodsSpecService.getOne(new LambdaQueryWrapper<GoodsSpec>().eq(GoodsSpec::getGoodsId, id).last("limit 1"));
      if (spec != null) {
        final String specValue = spec.getSpecValue();
        final Object object = JSONUtil.parseObject(specValue, Object.class);
        goods.setGoodsSpecValue(object);
      }
      // 整理商品价格
      final User loginUser = getLoginUser();
      if (loginUser != null) {
        if(loginUser.getGradeId().equals(33)){
          goods.setPrice(goods.getDealerPrice());
        }
        if(loginUser.getGradeId().equals(0)){
          goods.setPrice(goods.getSalePrice());
        }
      }
      // 店铺信息
      goods.setMerchant(merchantService.getOne(new LambdaUpdateWrapper<Merchant>().eq(Merchant::getMerchantId, goods.getMerchantId())));

      return success(goods);
    }

  @PreAuthorize("hasAuthority('shop:goods:save')")
  @ApiOperation("添加商品记录表")
  @PostMapping()
  public ApiResult<?> save(@RequestBody Goods goods) {
    // 记录当前登录用户id
    User loginUser = getLoginUser();
    if (loginUser != null) {
      goods.setUserId(loginUser.getUserId());
    }
    if (goodsService.save(goods)) {
      // 保存商品规格及sku信息
      goodsService.saveBatchByAsync(goods);
      return success("添加成功");
    }
    return fail("添加失败");
  }

  @PreAuthorize("hasAuthority('shop:goods:update')")
  @ApiOperation("修改商品记录表")
  @PutMapping()
  public ApiResult<?> update(@RequestBody Goods goods) {
    if (goodsService.updateById(goods)) {
      // 删除旧信息
      goodsSpecService.remove(new LambdaQueryWrapper<GoodsSpec>().eq(GoodsSpec::getGoodsId, goods.getGoodsId()));
      goodsSkuService.remove(new LambdaQueryWrapper<GoodsSku>().eq(GoodsSku::getGoodsId, goods.getGoodsId()));
      // 保存商品规格及sku信息
      goodsService.saveBatchByAsync(goods);
      return success("修改成功");
    }
    return fail("修改失败");
  }

  @PreAuthorize("hasAuthority('shop:goods:remove')")
  @ApiOperation("删除商品记录表")
  @DeleteMapping("/{id}")
  public ApiResult<?> remove(@PathVariable("id") Integer id) {
    if (goodsService.removeById(id)) {
      return success("删除成功");
    }
    return fail("删除失败");
  }

  @PreAuthorize("hasAuthority('shop:goods:save')")
  @ApiOperation("批量添加商品记录表")
  @PostMapping("/batch")
  public ApiResult<?> saveBatch(@RequestBody List<Goods> list) {
    if (goodsService.saveBatch(list)) {
      return success("添加成功");
    }
    return fail("添加失败");
  }

  @PreAuthorize("hasAuthority('shop:goods:update')")
  @ApiOperation("批量修改商品记录表")
  @PutMapping("/batch")
  public ApiResult<?> removeBatch(@RequestBody BatchParam<Goods> batchParam) {
    if (batchParam.update(goodsService, "goods_id")) {
      return success("修改成功");
    }
    return fail("修改失败");
  }

  @PreAuthorize("hasAuthority('shop:goods:remove')")
  @ApiOperation("批量删除商品记录表")
  @DeleteMapping("/batch")
  public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
    if (goodsService.removeByIds(ids)) {
      return success("删除成功");
    }
    return fail("删除失败");
  }

  @ApiOperation("统计信息")
  @GetMapping("/data")
  public ApiResult<Map<String, Integer>> data(GoodsParam param) {
    Map<String, Integer> data = new HashMap<>();
    final LambdaQueryWrapper<Goods> wrapper = new LambdaQueryWrapper<>();

    if (param.getMerchantId() != null) {
      wrapper.eq(Goods::getMerchantId,param.getMerchantId());
    }

    Integer totalNum = goodsService.count(
      wrapper.eq(Goods::getIsShow,1).gt(Goods::getStock,0)
    );
    data.put("totalNum", totalNum);

    Integer totalNum2 = goodsService.count(
      wrapper.eq(Goods::getIsShow,0)
    );
    data.put("totalNum2", totalNum2);

    Integer totalNum3 = goodsService.count(
      wrapper.eq(Goods::getStock,0)
    );
    data.put("totalNum3", totalNum3);

    // 下架已售罄的商品
    goodsService.update(new LambdaUpdateWrapper<Goods>().eq(Goods::getStock,0).eq(Goods::getIsShow,1).set(Goods::getIsShow,0));

    return success(data);
  }
}
